<!DOCTYPE html>
<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <style>
        canvas {
            border: 0px solid #d3d3d3;
            margin: 0px;
            background-color: #f1f1f1;
        }

        body {
            border: 0px solid #d3d3d3;
            margin: 0px;
            background-color: #f1f1f1;
        }
    </style>
</head>

<body><!--  -->
    <canvas id="canvasGame" width="900" height="900"> </canvas>
    <p id="mensajeinicial">Bienvenido</p>
    <script src="https://cdn.socket.io/4.5.4/socket.io.min.js"></script>
    <!-- <script type="text/javascript" src="./js/main.js"></script> -->


    <script>
        var parrafo = document.getElementById("mensajeinicial");
        var piezasSinJugar = [7, 7, 7, 7];
        const queryString = window.location.search;
        const urlParams = new URLSearchParams(queryString);
        const username = urlParams.get('username');
        const token = urlParams.get('token');
        const imageHostURL = "https://domino-work.s3.amazonaws.com/images/"

        var socket = io('http://localhost:8831');


        socket.emit("connect-player", {
            username,
            token
        });

        socket.on("start-game", (partida) => {

            console.log("Empezando partidas con datos: ");
            console.log(partida)
            partidaAct=partida;
            jugador = partida.jugadores.find(jugador => jugador.username == username);
            if (!jugador) return; //verifica si el jugador pertenece a la partida

            startGame(jugador, partida);
        });

        socket.on("juega-pieza", (data) => {
            JugarPieza(data.posicion, data.nombrePieza, data.culebra);
            canvasELF = data.turno == jugador.posicion;

            if (canvasELF) {

            }
            //actualizar visualmente
        })

        var jugador;
        var partidaAct;
        var borrar = 1;
        var pSelect = 1;
        var seleccion = false;
        var piezaJugar = -1;
        var accion = "Jugar";
        // variables de canvas globales
        var ctxOffscreen;

        // Crear un array para almacenar las imágenes
        var arrayImagesh = [];
        var arrayImagesv = [];

        var arrayRutaNombres = []
        // se crean todos los nombres de los archivos de piezas sin orientacion en un vector
        const piezasN = [];
        // se cargan todas piezas horizontales y verticales
        var vect = [];
        var mouseX = -1;
        var mouseY = -1;
        var totalImagenesh = 0;
        var loadedImagenesh = 0;
        var totalImagenesv = 0;
        var loadedImagenesv = 0;
        var piezasV = false;
        var piezasH = false;
        var imagenTablero;
        var piezaVerticalV;
        var piezaVerticalH;
        var tableroListo = false;
        var piezaVerticalHListo = false;
        var piezaVerticalVListo = false;
        var posColaX = 0;
        var posCabezaX = 0;
        var posColaY = 0;
        var posCabezaY = 0;
        var numCola = 0;
        var numCabeza = 0;
        var colaDir = -1;
        var cabezaDir = 1;
        var ultimaColaDoble = false;
        var ultimaCabezaDoble = false;
        var colaVuelta = false;
        var cabezaVuelta = false;
        var fichaDobleCola = false;
        var fichaDobleCabeza = false;
        var fichaAnteriorDobleCola = false;
        var fichaAnteriorDobleCabeza = false;

        // pre carga de imagenes
        PreCarga();

        // event listeners
        var canvasELF = -1;
        var canvasE = document.getElementById('canvasGame');

        function onClick(event) {

            //si clickeo en una pieza y es mi turno
            //emit jugare pieza

            console.log(socket);

            //canvasE.mo
            //verificar si es el jugador actual
            // socket.emit("jugare-pieza", ()=>{

            // })

            //console.log("event listener cargado");
            //console.log(canvasELF);

            if (canvasELF) {

                if (BuscarPiezaAJugar(0, jugador)) {
                    Redibujar();
                    mouseX = event.clientX;
                    mouseY = event.clientY;
                    console.log("mouseX" + mouseX);
                    console.log("mouseY" + mouseY);
                    for (var i = 0; i < vect.length; i++) {
                        var x1 = myGamePieza[0][vect[i]].x;
                        var y1 = myGamePieza[0][vect[i]].y;
                        var x2 = x1 + myGamePieza[0][vect[i]].width;
                        var y2 = y1 + myGamePieza[0][vect[i]].height;
                        if (mouseX > x1 && mouseX < x2 && mouseY > y1 && mouseY < y2) {
                            socket.emit("jugare-pieza", {
                                posicion: jugador.posicion,
                                nombrePieza: vect[i],
                                culebra: 0
                            });
                            break;
                        }
                    }
                    // seleccionar en donde, de ser necesario
                    var ladoCulebra = -1; // por defecto la pone en la cola
                    if (numCola != numCabeza) {
                        var v1 = myGamePieza[0][vect[i]].valor1;
                        var v2 = myGamePieza[0][vect[i]].valor2;
                        if ((v1 == numCola || v2 == numCola) && (v1 == numCabeza || v2 == numCabeza))    // hay que escoger en donde
                            if (v1 == numCola || v2 == numCola)
                                ladoCulebra = 1;
                    }
                    // busca la pieza entre las originales del jugador y la juega
                    for (var j = 0; j < jugador.piezas.length; j++) {
                        if (jugador.piezas[j].nombre == myGamePieza[0][pSelect].pieza)
                            break;
                    }
                    socket.emit("jugare-pieza",
                        {
                            posicion: jugador.posicion,
                            nombrePieza: jugador.piezas[j].nombre,
                            culebra: ladoCulebra
                        }
                    )

                } else
                    socket.emit("paso", jugador.posicion);
            }
        }

        // document.getElementById("miElemento").addEventListener("click", miEventListener);
        canvasE.addEventListener("click", onClick);

        // fin event listeners
        // tamaño de ventana windows y navegador
        var winWidth = window.innerWidth;
        var winHeight = window.innerHeight;
        var screenH = screen.availHeight;
        var screenW = screen.availWidth;
        var relacionPantalla = screenH / screenW;
        var canvasGame; // canvas del juego
        var tableroSize; // tamaño ,aximo del tablero
        if (winHeight > winWidth)
            tableroSize = winWidth;
        else
            tableroSize = winHeight;

        var escalaPieza = tableroSize / 374 / 12; // escala para las piezas, estimando 12 horizontales max




        document.body.style.overflow = "hidden";    // suprime las scrolls bars

        // variables globales
        const puntosPartA = 0; // puntaje equipo A o Jugador A en la Partida actual
        const puntosPartB = 0; // puntaje equipo B o Jugador B en la Partida actual
        const puntosTotalA = 0; // puntaje total del equipo A o Jugador A en lodas las partidas jugadas
        const puntosTotalB = 0; // puntaje total del equipo B o Jugador B en lodas las partidas jugadas
        const inicioYo = false; // flag de que tengo o no la cochina
        const pi = Math.PI; // 90 grados
        var sangria = 6; // porcentaje  del tablero del borde a las piezas del jugador
        var distPiezas = 4; // distancia de separacion entre piezas del jugador

        var myGamePieza = [];     // matriz de piezas del juego ya repartidas
        myGamePieza[0] = [];      // piezas del jugador 0, es la instancia
        myGamePieza[1] = [];      // piezas del jugador 1, es el jugador a la derecha
        myGamePieza[2] = [];      // piezas del jugador 2, es el jugador de enfrente, l compañero
        myGamePieza[3] = [];      // piezas del jugador 3, es el jugador a la izquierda
        var myGameCulebraIni;        // pieza dek centro de la culebra
        var myGameCulebraCola = []; // piezas del centro a la Cola de la culebra
        var myGameCulebraCola = []; // piezas del centro a la Cola de la cola


        // ojo de llamarse desde un boton o un evento para que funcione. revisar
        // window.resizeTo(tableroSize, tableroSize);

        // de jugador listo al servidor
        // comunicacion con el servidor esperando que todos los jugadores estan listos

        const piezasRepartidas = [];  // matriz con las piezas repartidas

        piezasRepartidas[0] = [];      // el jugador 0, es la instancia
        piezasRepartidas[1] = [];      // el jugador 1, es el jugador a la derecha
        piezasRepartidas[2] = [];      // el jugador 2, es el jugador de enfrente, l compañero
        piezasRepartidas[3] = [];      // el jugador 3, es el jugador a la izquierda

        // solo para debug estatico
        /*
        piezasRepartidas[0] = [ { nombre: "06", pos: 6 }, { nombre: "44", pos: 22 }, { nombre: "02", pos: 2 },
                                { nombre: "46", pos: 24 }, { nombre: "02", pos: 2 }, { nombre: "05", pos: 5 },
                                { nombre: "22", pos: 13 }];
        piezasRepartidas[1] = [ { nombre: "00", pos: 0  }, { nombre: "45", pos: 23 }, { nombre: "16", pos: 12 },
                                { nombre: "66", pos: 27 }, { nombre: "35", pos: 20 }, { nombre: "24", pos: 15 },
                                { nombre: "04", pos: 4 }];      // el jugador 1, es el jugador a la derecha
        piezasRepartidas[2] = [ { nombre: "11", pos: 7 }, { nombre: "36", pos: 21 }, { nombre: "13", pos: 9 },
                                { nombre: "15", pos: 11 }, { nombre: "46", pos: 24 }, { nombre: "25", pos: 16 },
                                { nombre: "23", pos: 14 }];      // el jugador 2, es el jugador de enfrente, l compañero
        piezasRepartidas[3] = [ { nombre: "12", pos: 8 }, { nombre: "14", pos: 10 }, { nombre: "03", pos: 3 },
                                { nombre: "34", pos: 19 }, { nombre: "56", pos: 26 }, { nombre: "55", pos: 25 },
                                { nombre: "01", pos: 1 }];      // el jugador 3, es el jugador a la izquierda
        
        */
        function PiezaNN(nombre, pos) {
            this.nombre = nombre;
            this.pos = pos;
        }

        function PreCarga() {
            for (let i = 0; i < 7; i++)
                for (let j = i; j < 7; j++) {
                    var nombre = i.toString() + j.toString();
                    var pieza = new PiezaNN(nombre, totalImagenesh);
                    piezasN.push(pieza); // 00,01,02.....56,66
                    arrayImagesh[totalImagenesh] = new Image(); // 00h,01h,02h....56h,66h
                    arrayImagesh[totalImagenesh].src = imageHostURL + nombre + "h.png";

                    arrayImagesh[totalImagenesh++].onload = function () {
                        loadedImagenesh++;
                        if (loadedImagenesh == arrayImagesh.length) {
                            // Todas las imágenes se han cargado, dibujarlas en el lienzo
                            piezasH = true;
                        }
                    };

                    // verticales
                    arrayImagesv[totalImagenesv] = new Image(); // 00h,01v,02v....56v,66v
                    arrayImagesv[totalImagenesv].src = imageHostURL + nombre + "v.png";
                    // arrayImagesh.push(im);
                    arrayImagesv[totalImagenesv++].onload = function () {
                        loadedImagenesv++;
                        if (loadedImagenesv == arrayImagesv.length) {
                            // Todas las imágenes se han cargado, dibujarlas en el lienzo
                            piezasH = true;
                        };
                    }
                }

            // se cargan las piezas del los otros jugadores (no se ven) y el tablero
            // imagenes cargadas:
            // arrayImagesh -> arreglo de las piezas horizontales
            // arrayImagesv -> arreglo de las piezas verticales
            // imagenTablero -> imagen del tablero
            // piezaVerticalH -> imagen de las piezas que no soy yo horizontal
            // piezaVerticalV -> imagen de las piezas que no soy yo vertical


            imagenTablero = new Image();
            piezaVerticalV = new Image();
            piezaVerticalH = new Image();
            tableroListo = false;
            piezaVerticalHListo = false;
            piezaVerticalVListo = false;
            imagenTablero.src = imageHostURL + "Tabla.jpg";
            piezaVerticalH.src = imageHostURL + "verticalh.png";
            piezaVerticalV.src = imageHostURL + "verticalv.png";

            imagenTablero.onload = function () {
                tableroListo = true;
            };
            piezaVerticalH.onload = function () {
                piezaVerticalHListo = true;
            };
            piezaVerticalV.onload = function () {
                piezaVerticalVListo = true;
            };
        }



        function startGame(jugador, partida) {
            // arrayImagesh -> arreglo de las piezas horizontales
            // arrayImagesv -> arreglo de las piezas verticales
            // imagenTablero -> imagen del tablero
            // piezaVerticalH -> imagen de las piezas que no soy yo horizontal
            // piezaVerticalV -> imagen de las piezas que no soy yo vertical
            // inicializa tablero
            myGameBoard = new Component("99", tableroSize, tableroSize,
                imagenTablero, 0, 0, "image", 0, 0); // /escalaPieza

            // inicializa piezas
            const miPosicion = jugador.posicion;
            for (let i = 0; i < 4; i++) {
                const t = (i + miPosicion) % 4;
                //console.log(t);
                if (i == 0) { // yo, la instancia
                    var inicioX = (tableroSize - (7 * 208 * escalaPieza + 6 * distPiezas)) / 2;//-208*escalaPieza+ tableroSize/100;
                    var inicioY = tableroSize - tableroSize * sangria / 100 - 374 * escalaPieza - tableroSize / 100;
                    var dx = 208 * escalaPieza + distPiezas;
                    var dy = 0;
                    var orient = "v";
                }
                if (i == 1) { // el que sigue a la derecha
                    var inicioX = tableroSize - tableroSize * sangria / 100 - tableroSize / 100 - 75 * escalaPieza;
                    var inicioY = tableroSize - (tableroSize - (7 * 208 * escalaPieza + 6 * distPiezas)) / 2 - 208 * escalaPieza;
                    var dx = 0;
                    var dy = -208 * escalaPieza - distPiezas;
                    var orient = "h";
                }
                if (i == 2) { // mi compañero de enfrente
                    var inicioX = tableroSize - (tableroSize - (7 * 208 * escalaPieza + 6 * distPiezas)) / 2 - 208 * escalaPieza;
                    var inicioY = tableroSize * sangria / 100 + tableroSize / 100;
                    var dx = -208 * escalaPieza - distPiezas;
                    var dy = 0;
                    var orient = "v";
                }
                if (i == 3) { // el anterior a mi, a la izquierda
                    var inicioX = tableroSize / 100 + tableroSize * sangria / 100;
                    var inicioY = (tableroSize - (7 * 208 * escalaPieza + 6 * distPiezas)) / 2;
                    var dx = 0;
                    var dy = +208 * escalaPieza + distPiezas;
                    var orient = "h";

                }
                // crea componentes de todas las piezas

                const player = partida.jugadores[t];

                for (let j = 0; j < 7; j++) {
                    if (i == 0) {
                        piezaAMostrar = imageHostURL + player.piezas[j] + orient + ".png";
                        //var f = new Pieza(piezaAMostrar,0,0,i,j,0,0,0,0,0);

                        myGamePieza[t][j] = new Component(player.piezas[j].nombre, 208 * escalaPieza, 374 * escalaPieza,
                            arrayImagesv[player.piezas[j].pos], inicioX + dx * j, inicioY + dy * j, "image", 0, 0);
                    }
                    else if (i == 2) {
                        piezaAMostrar = piezaVerticalV;
                        myGamePieza[t][j] = new Component(player.piezas[j].nombre, 208 * escalaPieza, 75 * escalaPieza, piezaAMostrar, inicioX + dx * j, inicioY + dy * j, "image", 0, 0);
                    }
                    else {
                        piezaAMostrar = piezaVerticalH;
                        // piezaAMostrar = arrayImagesv[jugador.piezas[j].pos];
                        myGamePieza[t][j] = new Component(player.piezas[j].nombre, 75 * escalaPieza, 208 * escalaPieza, piezaAMostrar, inicioX + dx * j, inicioY + dy * j, "image", 0, 0);
                    }
                }

            }

            var tengoCochina = jugador.piezas.findIndex(pieza => pieza.nombre == "66");

            if (tengoCochina != -1) {
                socket.emit("jugare-pieza", {
                    posicion: jugador.posicion,
                    nombrePieza: "66",
                    culebra: 0
                });
                console.log("Tengo la cochina");
            }
            myGameArea();
        }

        window.addEventListener('resize', function (event) { /// ojo esto hay que revisarlo

            let winW = window.innerWidth;
            let winH = window.innerHeight;

            console.log("resize detectado");
            if (winH / winW > relacionPantalla) {
                winH = winW * relacionPantalla;
            }
            else {
                winW = winH / relacionPantalla;

            }
            window.resizeTo(winH, winW);
            winWidth = window.innerWidth;
            winHeight = window.innerHeight;
            if (winHeight > winWidth)
                tableroSize = winWidth;
            else
                tableroSize = winHeight;

            escalaPieza = tableroSize / 374 / 12; // escala para las piezas, estimando 12 horizontales

        });

        function myGameArea() {

            Redibujar();

            /*
            switch (accion) {
                case "Jugar":
                    console.log("entro en jugar");
                    canvasELF = true;
                    var vecto = BuscarPiezaAJugar(-1);
                    MostrarJugar(vecto);
                    accion = "no hacer nada";
                    break;
                case "Jugo":
                    canvasELF = false;
                    var vecto = BuscarPiezaAJugar(0);
                    vect = vecto;
                    Redibujar();
        
                    break;
                case "no hacer nada":
                default:
                    break;
            }
            */


            animationId = requestAnimationFrame(myGameArea);

        }

        function Redibujar() {
            // Crear un lienzo off-screen
            var canvasOffscreen = document.createElement('canvas');
            // Dibujar en el lienzo off-screen
            canvasOffscreen.width = winWidth;   //device-width
            canvasOffscreen.height = winWidth;  //device-height
            ctxOffscreen = canvasOffscreen.getContext('2d');

            updateGameArea();

            canvasOnscreen = document.getElementById('canvasGame');

            // Presentar el lienzo listo en la pantalla
            canvasOnscreen.width = winWidth;   //device-width
            canvasOnscreen.height = winWidth;  //device-height
            var ctxOnscreen = canvasOnscreen.getContext('2d');
            ctxOnscreen.drawImage(canvasOffscreen, 0, 0);
        }

        function MostrarJugar(vect) {
            console.log("MostrarJugar");
            var canvas = document.getElementById("canvasGame");


            for (var i = 0; i < vect.length; i++) {
                myGamePieza[0][vect[i]].jugable = 1;
            }
            // para borrarmyGamePieza[0][cur].jugable=0;

            Redibujar();

            pSelect = SeleccionarPieza(vect);
            //JugarPieza(0,pSelect,-1/*ladoCulebra*/);// 2 3

        }

        function SeleccionarPieza(vect) {
            pSelect = -1;
            canvasELF = true;
            console.log("Seleccionar Pieza");

            //while(pSelect==-1) {
            Redibujar();
            //}

            canvasELF = false;
            return pSelect;
        }

        function BuscarPiezaAJugar(inicio, jugador) {
            console.log("BuscarPiezaAJugar");
            var jug = 0;
            var piezasPosibles = [];
            var v1 = -1;
            var v2 = -1;
            if (inicio == -1) {     // si puede jugar cualquier pieza, 2nda partida
                for (var i = 0; i < 7; i++)
                    myGamePieza[jug][i].jugable = 1;
                return [0, 1, 2, 3, 4, 5, 6];
            }
            var k2 = 0;
            for (var i = 0; i < 7; i++)
                myGamePieza[0][i].jugable = 0;
            for (var i = 0; i < jugador.piezas.length; i++)
                for (var k = k2; k < 7; k++) {
                    if (jugador.piezas[i].nombre == myGamePieza[0][k].pieza) {
                        k2 = k;
                        v1 = jugador.piezas[i].nombre[0];
                        v2 = jugador.piezas[i].nombre[1];

                        if (numCola == v1 || numCola == v2) {
                            piezasPosibles.push(k);  // son los indices de las piezas en la mano original
                            myGamePieza[0][k].jugable = 1;
                        }
                        else if (numCabeza == v1 || numCabeza == v2) {
                            piezasPosibles.push(k);  // son los indices de las piezas en la mano original
                            myGamePieza[0][k].jugable = 1;
                        }
                        break;
                    }
                }
            return piezasPosibles;
        }

        function JugarPieza(jug, nombPieza, ladoCulebra) { // -1 cola, 0 cuerpo y 1 Cola
            console.log("JugarPieza");
            console.log(jug, nombPieza, ladoCulebra);
            console.log(myGamePieza[jug][0].pieza,myGamePieza[jug][1].pieza,"...",myGamePieza[jug][6].pieza);
            //var jug=(jugr+1)%4;
            // 0...3    nombre pieza en la mano
            fichaDobleCabeza = false;
            // colaDir = ladoCulebra;
            var piezaJugada;
            var i = 0;
            piezasSinJugar[jug]--;
            //console.log(partidaAct.jugadores);
            for (i = 0; i < jugador.piezas.length; i++) {
                if (partidaAct.jugadores[jug].piezas[i].nombre == nombPieza) {
                    piezaJugada = myGamePieza[jug][i];
                    break;
                }
            }
            console.log("pieza posicion " + i);
            console.log("piezaJugada.pieza " + piezaJugada.pieza); //console.log(myGamePieza[jugr][i]);
            console.log("partidaAct.jugadores[jug].piezas[i].nombre" + partidaAct.jugadores[jug].piezas[i].nombre);
            
            var pos = partidaAct.jugadores[jug].piezas[i].pos;
            myGamePieza[jug][i].width = 374 * escalaPieza;
            myGamePieza[jug][i].height = 208 * escalaPieza;
            myGamePieza[jug][i].Image = arrayImagesh[pos];
            
            
            //console.log(pos);


            if (ladoCulebra == 0) {
                myGameCulebraIni = piezaJugada;
                if (myGameCulebraIni.valor1 == myGameCulebraIni.valor2) { //vertical
                    myGamePieza[jug][i].Image = arrayImagesv[pos];
                    myGamePieza[jug][i].width = 208 * escalaPieza;
                    myGamePieza[jug][i].height = 374 * escalaPieza;
                    myGamePieza[jug][i].x = tableroSize / 2 - 208 * escalaPieza / 2;
                    myGamePieza[jug][i].y = tableroSize / 2 - 374 * escalaPieza / 2
                    posCabezaX = tableroSize / 2 + 208 * escalaPieza / 2;
                    posCabezaY = tableroSize / 2 - 208 * escalaPieza / 2;
                    posColaX = tableroSize / 2 - 208 * escalaPieza / 2;
                    posColaY = tableroSize / 2 - 208 * escalaPieza / 2;
                    numCola = myGameCulebraIni.valor1;
                    numCabeza = myGameCulebraIni.valor2;
                }
                else {   // horizontal
                    myGamePieza[jug][i].Image = arrayImagesh[pos];
                    myGamePieza[jug][i].width = 374 * escalaPieza;
                    myGamePieza[jug][i].height = 208 * escalaPieza;
                    myGamePieza[jug][i].x = tableroSize / 2 - 374 * escalaPieza / 2;
                    myGamePieza[jug][i].y = tableroSize / 2 - 208 * escalaPieza / 2
                    posCabezaX = tableroSize / 2 + 374 * escalaPieza / 2;
                    posCabezaY = tableroSize / 2 - 208 * escalaPieza / 2;
                    posColaX = tableroSize / 2 - 374 * escalaPieza / 2;;
                    posColaY = tableroSize / 2 - 208 * escalaPieza / 2;
                    numCola = myGameCulebraIni.valor1;
                    numCabeza = myGameCulebraIni.valor2;
                }
            }
            else if (ladoCulebra == -1) {   // cola izquierda inicialmente
                myGameCulebraCola = piezaJugada;
                // numCola

                var doble = false;
                var vertical = false;
                var x = posColaX + colaDir * (374 * escalaPieza + 10); // para ver si se llego al limite y hay que bajar

                var ColaIzqLimite = false;
                var ColaDerLimite = false;
                var bajar = false;
                fichaDobleCola = false;
                if (x < (sangria + 474) * escalaPieza && colaDir == -1) {
                    vertical = true;
                    bajar = true;
                    ColaIzqLimite = true;
                }
                if (x > tableroSize - (sangria + 474) * escalaPieza && colaDir == 1) {
                    vertical = true;
                    bajar = true;
                    ColaDerLimite = true;
                }
                //if(vertical && ultimaColaDoble)
                //    subir=true;
                if (myGameCulebraCola.valor1 == myGameCulebraCola.valor2) {
                    fichaDobleCola = true;
                    doble = true;
                    vertical = true;
                }

                if (colaVuelta) {
                    fichaDobleCola = true;
                    vertical = false;
                    doble = false;
                    bajar = false;
                    colaVuelta = false;
                }

                if (vertical) {
                    myGamePieza[jug][i].Image = arrayImagesv[pos];
                    myGamePieza[jug][i].height = 374 * escalaPieza;
                    myGamePieza[jug][i].width = 208 * escalaPieza;
                    // si es vertical, es un doble o se baja
                    // ver si hay que rotarla, aqui se baja o es un doble vertical

                    var vr1 = myGamePieza[jug][i].valor1;
                    var vr2 = myGamePieza[jug][i].valor2;
                    if (numCola == vr2) {    // rotar
                        myGamePieza[jug][i].rotar = 1;
                        numCola = vr1;
                    }
                    else {
                        myGamePieza[jug][i].rotar = 0;
                        numCola = vr2;
                    }


                    if (doble) {
                        if (bajar) {  // doble
                            if (colaDir == 1) {
                                myGamePieza[jug][i].x = posColaX - 208 * escalaPieza;
                                myGamePieza[jug][i].y = posColaY + 208 * escalaPieza;
                                posColaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                posColaY = myGamePieza[jug][i].y + 374 * escalaPieza;
                                colaDir = -1;
                            }
                            else {
                                myGamePieza[jug][i].x = posColaX;
                                myGamePieza[jug][i].y = posColaY + 208 * escalaPieza;
                                posColaX = myGamePieza[jug][i].x;
                                posColaY = myGamePieza[jug][i].y + 374 * escalaPieza;
                                colaDir = 1;
                            }
                        }
                        else {   // doble
                            ultimaColaDoble = true;
                            if (colaDir == 1) {
                                myGamePieza[jug][i].x = posColaX;
                                myGamePieza[jug][i].y = posColaY + 208 * escalaPieza / 2 - 374 * escalaPieza / 2;
                                posColaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                // posColaY = myGamePieza[jug][j].y + 374*escalaPieza/2-208*escalaPieza/2;
                            }
                            else {
                                myGamePieza[jug][i].x = posColaX - 208 * escalaPieza;
                                myGamePieza[jug][i].y = posColaY + 208 * escalaPieza / 2 - 374 * escalaPieza / 2;
                                posColaX = myGamePieza[jug][i].x;
                                posColaY = myGamePieza[jug][i].y - 208 * escalaPieza / 2 + 374 * escalaPieza / 2;
                            }
                        }
                        if (fichaAnteriorDobleCola && (ColaDerLimite || ColaIzqLimite)) {
                            myGamePieza[jug][i].y -= (374 - 208) * escalaPieza / 2;
                            posColaY -= (374 - 208) * escalaPieza / 2;
                        }

                    }
                    else { // no es doble
                        if (bajar) {
                            if (colaDir == 1) {
                                myGamePieza[jug][i].x = posColaX - 208 * escalaPieza;
                                myGamePieza[jug][i].y = posColaY + 208 * escalaPieza;
                                posColaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                posColaY = myGamePieza[jug][i].y + 374 * escalaPieza;
                                colaDir = -1; colaVuelta = true;

                            }
                            else {
                                myGamePieza[jug][i].x = posColaX;
                                myGamePieza[jug][i].y = posColaY + 208 * escalaPieza;
                                posColaX = myGamePieza[jug][i].x;
                                posColaY = myGamePieza[jug][i].y + 378 * escalaPieza;
                                colaDir = +1; colaVuelta = true;

                            }
                        }
                        else {
                            if (colaDir == 1) {
                                myGamePieza[jug][i].x = posColaX;
                                myGamePieza[jug][i].y = posColaY - 374 * escalaPieza / 2;
                                if (ColaDerLimite) {
                                    posColaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                    posColaY = myGamePieza[jug][i].y - 374 * escalaPieza;
                                    //colaDir = -1;
                                }
                            }
                            else {
                                myGamePieza[jug][i].x = posColaX;
                                myGamePieza[jug][i].y = posColaY - 374 * escalaPieza;
                                if (ColaIzqLimite) {
                                    posColaX = myGamePieza[jug][i].x;
                                    posColaY = myGamePieza[jug][i].y - 374 * escalaPieza;
                                    colaDir = +1;
                                }
                            }
                        }
                        if (fichaAnteriorDobleCola && (ColaDerLimite || ColaIzqLimite)) {
                            myGamePieza[jug][i].y += (374 - 208) * escalaPieza / 2;
                            posColaY += (374 - 208) * escalaPieza / 2;
                        }
                    }
                }
                else {   // horizontal
                    myGamePieza[jug][i].Image = arrayImagesh[pos];
                    myGamePieza[jug][i].height = 208 * escalaPieza;
                    myGamePieza[jug][i].width = 374 * escalaPieza;

                    // si es horizontal puede ser cualquier pieza
                    // ver si hay que rotarla
                    var vr1 = myGamePieza[jug][i].valor1;
                    var vr2 = myGamePieza[jug][i].valor2;
                    if (colaDir == 1) {
                        if (numCola == vr2) {    // rotar
                            myGamePieza[jug][i].rotar = 1;
                            numCola = vr1;
                        }
                        else {
                            myGamePieza[jug][i].rotar = 0;
                            numCola = vr2;
                        }
                    }
                    else {
                        if (numCola == vr1) {    // rotar
                            myGamePieza[jug][i].rotar = 1;
                            numCola = vr2;
                        }
                        else {
                            myGamePieza[jug][i].rotar = 0;
                            numCola = vr1;
                        }
                    }


                    if (colaDir == 1) {
                        myGamePieza[jug][i].x = posColaX;
                        myGamePieza[jug][i].y = posColaY;
                        posColaX = myGamePieza[jug][i].x + 374 * escalaPieza;
                        posColaY = myGamePieza[jug][i].y;
                        if (colaVuelta && ultimaColaDoble) {
                            // posColaY -= (374-208)*escalaPieza/2;
                            colaVuelta = false;
                            ultimaColaDoble = false;
                        }
                    }
                    else {
                        myGamePieza[jug][i].x = posColaX - 374 * escalaPieza;
                        myGamePieza[jug][i].y = posColaY;
                        posColaX = myGamePieza[jug][i].x;
                        posColaY = myGamePieza[jug][i].y;
                        if (colaVuelta && ultimaColaDoble) {
                            posColaY -= (374 - 208) / 2;
                            colaVuelta = false;
                            ultimaColaDoble = false;
                        }
                    }
                }
                if (fichaDobleCola)
                    fichaAnteriorDobleCola = true;
                else
                    fichaAnteriorDobleCola = false;
            }
            else if (ladoCulebra == 1) {   // Cabeza derecha inicialmente
                myGameCulebraCabeza = piezaJugada;


                var doble = false;
                var vertical = false;
                var x = posCabezaX + cabezaDir * (374 * escalaPieza + 10); // para ver si se llego al limite y hay que subir

                var CabezaIzqLimite = false;
                var CabezaDerLimite = false;
                var subir = false;
                fichaDobleCabeza = false; // ojo comprobar
                if (x < (sangria + 474) * escalaPieza && cabezaDir == -1) {
                    vertical = true;
                    subir = true;
                    CabezaIzqLimite = true;
                }
                if (x > tableroSize - (sangria + 474) * escalaPieza && cabezaDir == 1) {
                    vertical = true;
                    subir = true;
                    CabezaDerLimite = true;
                }
                //if(vertical && ultimaCabezaDoble)
                //    subir=true;
                if (myGameCulebraCabeza.valor1 == myGameCulebraCabeza.valor2) {
                    fichaDobleCabeza = true;
                    doble = true;
                    vertical = true;
                }

                if (cabezaVuelta) {
                    fichaDobleCabeza = true;
                    vertical = false;
                    doble = false;
                    subir = false;
                    cabezaVuelta = false;
                }

                if (vertical) {
                    myGamePieza[jug][i].Image = arrayImagesv[pos];
                    myGamePieza[jug][i].height = 374 * escalaPieza;
                    myGamePieza[jug][i].width = 208 * escalaPieza;

                    // si es vertical, es un doble o se sube
                    // ver si hay que rotarla, aqui se baja o es un doble vertical

                    var vr1 = myGamePieza[jug][i].valor1;
                    var vr2 = myGamePieza[jug][i].valor2;
                    if (numCabeza == vr1) {    // rotar
                        myGamePieza[jug][i].rotar = 1;
                        numCabeza = vr2;
                    }
                    else {
                        myGamePieza[jug][i].rotar = 0;
                        numCabeza = vr1;
                    }

                    if (doble) {
                        if (subir) {  // doble
                            if (cabezaDir == 1) {
                                myGamePieza[jug][i].x = posCabezaX - 208 * escalaPieza;
                                myGamePieza[jug][i].y = posCabezaY - 374 * escalaPieza;
                                posCabezaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                posCabezaY = myGamePieza[jug][i].y - 208 * escalaPieza;
                                cabezaDir = -1;
                            }
                            else {
                                myGamePieza[jug][i].x = posCabezaX;
                                myGamePieza[jug][i].y = posCabezaY - 374 * escalaPieza;
                                posCabezaX = myGamePieza[jug][i].x;
                                posCabezaY = myGamePieza[jug][i].y - 208 * escalaPieza;
                                cabezaDir = 1;
                            }
                        }
                        else {   // doble
                            ultimaCabezaDoble = true;
                            if (cabezaDir == 1) {
                                myGamePieza[jug][i].x = posCabezaX;
                                myGamePieza[jug][i].y = posCabezaY + 208 * escalaPieza / 2 - 374 * escalaPieza / 2;
                                posCabezaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                posCabezaY = myGamePieza[jug][i].y + 374 * escalaPieza / 2 - 208 * escalaPieza / 2;
                            }
                            else {
                                myGamePieza[jug][i].x = posCabezaX - 208 * escalaPieza;
                                myGamePieza[jug][i].y = posCabezaY + 208 * escalaPieza / 2 - 374 * escalaPieza / 2;
                                posCabezaX = myGamePieza[jug][i].x;
                                posCabezaY = myGamePieza[jug][i].y - 208 * escalaPieza / 2 + 374 * escalaPieza / 2;
                            }
                        }
                        if (fichaAnteriorDobleCabeza && (CabezaDerLimite || CabezaIzqLimite)) {
                            myGamePieza[jug][j].y -= (374 - 208) * escalaPieza / 2;
                            posCabezaY -= (374 - 208) * escalaPieza / 2;
                        }
                    }
                    else { // no es doble
                        if (subir) {
                            if (cabezaDir == 1) {
                                myGamePieza[jug][i].x = posCabezaX - 208 * escalaPieza;
                                myGamePieza[jug][i].y = posCabezaY - 374 * escalaPieza;
                                posCabezaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                posCabezaY = myGamePieza[jug][i].y - 208 * escalaPieza;
                                cabezaDir = -1; cabezaVuelta = true;

                            }
                            else {
                                myGamePieza[jug][i].x = posCabezaX;
                                myGamePieza[jug][i].y = posCabezaY - 374 * escalaPieza;
                                posCabezaX = myGamePieza[jug][i].x;
                                posCabezaY = myGamePieza[jug][i].y - 208 * escalaPieza;
                                cabezaDir = +1; cabezaVuelta = true;

                            }
                        }
                        else {
                            if (cabezaDir == 1) {
                                myGamePieza[jug][i].x = posCabezaX;
                                myGamePieza[jug][i].y = posCabezaY - 374 * escalaPieza / 2;
                                if (CabezaDerLimite) {
                                    posCabezaX = myGamePieza[jug][i].x + 208 * escalaPieza;
                                    posCabezaY = myGamePieza[jug][i].y - 374 * escalaPieza;
                                    //cabezaDir = -1;
                                }
                            }
                            else {
                                myGamePieza[jug][i].x = posCabezaX;
                                myGamePieza[jug][i].y = posCabezaY - 374 * escalaPieza;
                                if (CabezaIzqLimite) {
                                    posCabezaX = myGamePieza[jug][i].x;
                                    posCabezaY = myGamePieza[jug][i].y - 374 * escalaPieza;
                                    cabezaDir = +1;
                                }
                            }
                        }
                        if (fichaAnteriorDobleCabeza && (CabezaDerLimite || CabezaIzqLimite)) {
                            myGamePieza[jug][i].y -= (374 - 208) * escalaPieza / 2;
                            posCabezaY -= (374 - 208) * escalaPieza / 2;
                        }
                    }
                }
                else {   // horizontal
                    myGamePieza[jug][i].Image = arrayImagesh[pos];
                    myGamePieza[jug][i].height = 208 * escalaPieza;
                    myGamePieza[jug][i].width = 374 * escalaPieza;
                    // si es horizontal puede ser cualquier pieza
                    // ver si hay que rotarla
                    var vr1 = myGamePieza[jug][i].valor1;
                    var vr2 = myGamePieza[jug][i].valor2;
                    if (cabezaDir == 1) {
                        if (numCabeza == vr2) {    // rotar
                            myGamePieza[jug][i].rotar = 1;
                            numCabeza = vr1;
                        }
                        else {
                            myGamePieza[jug][i].rotar = 0;
                            numCabeza = vr2;
                        }
                    }
                    else {
                        if (numCola == vr1) {    // rotar
                            myGamePieza[jug][i].rotar = 1;
                            numCola = vr2;
                        }
                        else {
                            myGamePieza[jug][i].rotar = 0;
                            numCola = vr1;
                        }
                    }


                    if (cabezaDir == 1) {
                        myGamePieza[jug][i].x = posCabezaX;
                        myGamePieza[jug][i].y = posCabezaY;
                        posCabezaX = myGamePieza[jug][i].x + 374 * escalaPieza;
                        posCabezaY = myGamePieza[jug][i].y;
                        if (cabezaVuelta && ultimaCabezaDobleCabeza) {
                            // posCabezaY -= (374-208)*escalaPieza/2;
                            cabezaVuelta = false;
                            ultimaCabezaDobleCabeza = false;
                        }
                    }
                    else {
                        myGamePieza[jug][i].x = posCabezaX - 374 * escalaPieza;
                        myGamePieza[jug][i].y = posCabezaY;
                        posCabezaX = myGamePieza[jug][i].x;
                        posCabezaY = myGamePieza[jug][i].y;
                        if (cabezaVuelta && ultimaCabezaDobleCabeza) {
                            posCabezaY -= (374 - 208) / 2;
                            cabezaVuelta = false;
                            ultimaCabezaDoble = false;
                        }
                    }
                }
                if (fichaDobleCabeza)
                    fichaAnteriorDobleCabeza = true;
                else
                    fichaAnteriorDobleCabeza = false;
            }

            if (jug == jugador.posicion) // soy yo
                jugador.piezas.splice(i, 1);

        }

        function Component(pieza, width, height, imag, x, y, type, jugable, rotar) {

            this.pieza = pieza; // nombre: de la pieza 00, 66 , pos: en el array de imagenes
            this.width = width;//*escala;
            this.height = height;//*escala;
            this.Image = imag;   // imagen de la pieza;
            this.type = type;
            /*
            if (type == "image") {
                this.image = new Image();
                this.image.src = color;
            }
            */
            this.valor1 = pieza[0];
            this.valor2 = pieza[1];
            this.x = x;
            this.y = y;
            this.jugable = jugable;
            this.rotar = rotar;

            this.update = function () {
                //var ctx = canvasGame.getContext('2d');
                if (this.jugable > 0) {
                    ctxOffscreen.fillStyle = "red";
                    ctxOffscreen.fillRect(this.x - 2, this.y - 2, this.width + 4, this.height + 4);
                    // dibujar el numero jugable arriba de la pieza
                    // ctxOffscreen.font = escalaPieza*100+'px Arial';
                    // ctxOffscreen.fillText(this.jugable.toString(), this.x + this.width/4, this.y-50*escalaPieza);
                }
                else
                    this.jugable = 0;
                if (this.rotar == 1) {
                    ctxOffscreen.translate(this.x + this.width / 2, this.y + this.height / 2);
                    ctxOffscreen.rotate(pi);
                    ctxOffscreen.drawImage(this.Image, -this.width / 2, -this.height / 2, this.width, this.height);
                }
                if (this.rotar == 1) {
                    ctxOffscreen.rotate(-pi);
                    ctxOffscreen.translate(-this.x - this.width / 2, -this.y - this.height / 2);
                    this.rotar == 0;
                }
                else
                    ctxOffscreen.drawImage(this.Image, this.x, this.y, this.width, this.height);

            }
        }

        function updateGameArea() {
            //myGameArea.clear();
            // myGamePiece.newPos();
            myGameBoard.update();
            //myGamePiece.update();
            //i=0;
            for (let i = 0; i < 4; i++)
                for (let j = 0; j < myGamePieza[i].length; j++)
                    myGamePieza[i][j].update();
        }


    </script>


</body>

</html>